/*!
 * @brief vision process module
 * $Date$
 * @author Nemoto,Mizoguchi lab,Tokyo University of Science
 * @mail:j7507640@ed.noda.tus.ac.jp
 * $Id$
 */

#include <stdio.h>
#include <string.h>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#include "global.h"
#include "stframe.h"
#include "Vision.h"
#include <time.h>

int vision_area_x_up=0;
int vision_area_y_up=0;
int vision_area_x_down=0;
int vision_area_y_down=0;

double person_position_x=0;
double person_position_y=0;

IplImage* frame=cvCreateImage(cvSize(WIDTH,HEIGHT),8,3);  
IplImage* object=cvCreateImage(cvSize(WIDTH,HEIGHT),8,3);  
IplImage* temp=NULL;


static HScolor hstable[BIT8][BIT8][BIT8];
static HShist HSGaussian[BIT8*BIT8];
static CLdata clust;
static double Gaussian[BIT8][BIT8]={{}};
static double ExtHist[BIT8][BIT8]={{}};
static double HShistgram[BIT8][BIT8]={{}};

static double *xx_v;
static double *yy_v;
static double *zz_v;
static int *aa_v;

bool mouse_flg=0;

IplImage* disp=cvCreateImage(cvSize(WIDTH,HEIGHT),8,1);   
IplImage* hsv=cvCreateImage(cvSize(BIT8,BIT8),8,1);   
IplImage* hsv_ori=cvCreateImage(cvSize(BIT8,BIT8),8,3);   
IplImage* gau=cvCreateImage(cvSize(BIT8,BIT8),8,1);   
IplImage* gau2=cvCreateImage(cvSize(BIT8,BIT8),8,1);   
IplImage* hsv_ori3=cvCreateImage(cvSize(BIT8,BIT8),8,1);   

IplImage* upext=NULL;
IplImage* target=cvCreateImage(cvSize(WIDTH,HEIGHT),8,3);
IplImage* target2=cvCreateImage(cvSize(WIDTH,HEIGHT),8,3);
unsigned char* data=(unsigned char*)frame->imageData;
int StereoDistance[WIDTH*HEIGHT];

char distanceTxt[20]={};

int proxmax,proymax;
int person_distance;
int plot_count=0;
CvFont font;

double disAve=0;

static double person_vision_x;
static double person_vision_y;
static double person_vision_z;

int key;
int num=0;
CvPoint xy,xy1;
double *distant;
double BACK=2.00;

void BackClear_Disp(IplImage *fram,IplImage *disp,IplImage *targ,int background){
    int BACK=background;
	int dis;
    for(int i=0;i<WIDTH*HEIGHT;i++){
        targ->imageData[i*3+2]=0;
        targ->imageData[i*3+1]=0;
        targ->imageData[i*3]=0;
		dis=(unsigned char)disp->imageData[i];
			 if(dis>BACK){
            targ->imageData[i*3+2]=fram->imageData[i*3+2];
            targ->imageData[i*3+1]=fram->imageData[i*3+1];
            targ->imageData[i*3]=fram->imageData[i*3];
        }
    }

}



void VisionImagePosOut(double &x,double &y){
	x=person_position_x;
	y=person_position_y;
}

void VisionImageAreaOut(double &xmin,double &ymin,double &xmax,double &ymax){
/*
	xmin=vision_area_x_up;
	ymin=vision_area_y_down;
	xmax=vision_area_x_up;
	ymax=vision_area_y_down;
*/
	xmin=vision_area_x_down;
	ymin=vision_area_y_down;
	xmax=vision_area_x_up;
	ymax=vision_area_y_up;
}

void BackClear(IplImage *fram,double *dis,IplImage *targ,double background){
    double BACK=background;
    for(int i=0;i<WIDTH*HEIGHT;i++){
        targ->imageData[i*3+2]=0;
        targ->imageData[i*3+1]=0;
        targ->imageData[i*3]=0;
        if((dis[i]<BACK)&&(dis[i]>0)){
            targ->imageData[i*3+2]=fram->imageData[i*3+2];
            targ->imageData[i*3+1]=fram->imageData[i*3+1];
            targ->imageData[i*3]=fram->imageData[i*3];
        }
    }
}

void Cover3d(int *ain,double *xin,double *yin,double *zin,double *xout,double *yout,double *zout){
    for(int i=0;i<WIDTH*HEIGHT;i++){
        if(ain[i]>0){
            xout[i]=xin[i];
            yout[i]=yin[i];
            zout[i]=zin[i];
        }
        else{
            xout[i]=0;
            yout[i]=0;
            zout[i]=0;
        }
    }

    int start;
    int end;

    int updown_para=80;
    int rightleft_para=100;

    double left_data;
    double right_data;

    for(int i=WIDTH;i<WIDTH*(HEIGHT-1);i++){
        if((zout[i]==0)&&(zout[i-1]!=0)){
            right_data=0;
            left_data=0;
            start=i;
            left_data=zout[i-1];
            if(left_data<1.500) rightleft_para=100;
            if(left_data>=1.500) rightleft_para=70;
            for(int j=0;j<rightleft_para;j++){
                if((i+j)%WIDTH==0) {
                    right_data=0;
                    break;
                }
                if(zout[i+j]!=0){
                    right_data=zout[i+j];
                    end=i+j;
                    break;
                }
            }

            if((right_data!=0)&&(fabs(right_data-left_data)<0.300)){
                for(int j=start;j<end;j++){
                    if((xout[j-WIDTH]!=0)&&yout[j-1]!=0){
                        xout[j]=xout[j-WIDTH]; 
                        yout[j]=yout[j-1];      
                        zout[j]=left_data;    
                    }

                }
            }
        }
    }

    double up_data;
    double down_data;
    for(int i=WIDTH;i<WIDTH*(HEIGHT-1);i++){
        if((zout[i]==0)&&(zout[i-WIDTH]!=0)){
            up_data=0;
            down_data=0;
            start=i;
            up_data=zout[i-WIDTH];
            for(int j=0;j<updown_para;j++){
                if((i+j*WIDTH)>WIDTH*(HEIGHT-1)) {
                    down_data=0;
                    break;
                }
                if(zout[i+j*WIDTH]!=0){
                    down_data=zout[i+j*WIDTH];
                    end=i+j*WIDTH;
                    break;
                }
            }
            if((down_data!=0)&&(fabs(down_data-up_data)<0.300)){
                for(int j=start;j<end;j+=WIDTH){
                    if((xout[j-WIDTH]!=0)&&yout[j-1]!=0){
                        xout[j]=xout[j-WIDTH]; 
                        yout[j]=yout[j-1]; 
                        zout[j]=up_data;
                    }
                }
            }
        }
    }

}

void Inputdis(double *dis_double,IplImage *disp,double *dis_out,int *parall){//補完しつつdoubleをintへ変換。

    for(int i=0;i<WIDTH*HEIGHT;i++){
        dis_out[i]=0;
        if(parall[i]>0)
            dis_out[i]=dis_double[i];
        else
            dis_out[i]=0;
    }

    int start;
    int end;

    int updown_para=80;
    int rightleft_para=100;

    double left_data;
    double right_data;
    for(int i=WIDTH;i<WIDTH*HEIGHT;i++){
        if((dis_out[i]==0)&&(dis_out[i-1]!=0)){
            right_data=0;
            left_data=0;
            start=i;
            left_data=dis_out[i-1];
            if(left_data<1.500) rightleft_para=100;
            if(left_data>=1.500) rightleft_para=50;
            for(int j=0;j<rightleft_para;j++){
                if((i+j)%WIDTH==0) {
                    right_data=0;
                    break;
                }
                if(dis_out[i+j]!=0){
                    right_data=dis_out[i+j];
                    end=i+j;
                    break;
                }
            }
            if((right_data!=0)&&(fabs(right_data-left_data)<0.300)){
                for(int j=start;j<end;j++){
                    dis_out[j]=left_data;
                }
            }
        }
    }

    double up_data;
    double down_data;
    for(int i=WIDTH;i<WIDTH*(HEIGHT-1);i++){
        if((dis_out[i]==0)&&(dis_out[i-WIDTH]!=0)){
            up_data=0;
            down_data=0;
            start=i;
            up_data=dis_out[i-WIDTH];
            for(int j=0;j<updown_para;j++){
                if((i+j*WIDTH)>WIDTH*(HEIGHT-1)) {
                    down_data=0;
                    break;
                }
                if(dis_out[i+j*WIDTH]!=0){
                    down_data=dis_out[i+j*WIDTH];
                    end=i+j*WIDTH;
                    break;
                }
            }
            if((down_data!=0)&&(fabs(down_data-up_data)<0.300)){
                for(int j=start;j<end;j+=WIDTH){
                    dis_out[j]=up_data;
                }
            }
        }
    }

    for(int i=0;i<WIDTH*HEIGHT;i++){
        disp->imageData[i]=(char)(256-(double)dis_out[i]/3.0*256);
    }
    
}



void OnMouse(int event, int x, int y, int flags, void *param);

void distance_cal(double *dist,int *aa,CvPoint xy,CvPoint xy1,double &ave,double BACK){
    long int sum=0;
    int num=0;
    long int ave_int;
    for(int i=xy.y;i<xy1.y;i++){
	for(int j=xy.x;j<xy1.x;j++){
	    if(aa[i*WIDTH+j]>0){
		if(dist[i*WIDTH+j]>0){
		if(dist[i*WIDTH+j]<BACK){
		    sum+=(int)(dist[i*WIDTH+j]*1000);
		    num++;
		    }
		}
	    }
	}
    }
    if(num!=0) {
	ave_int=sum/num;
        ave=ave_int/1000.0;
    }
}
void PositionCal(double *xx,double *yy,double *zz,int *aa,CvPoint xy,CvPoint xy1,double &person_x,double &person_y,double &person_z,double BACK){

	    long double sum_x=0;
	    long double sum_y=0;
	    long double sum_z=0;
	    long double ave_x=0;
	    long double ave_y=0;
	    long double ave_z=0;
	    
    int num=0;

    for(int i=xy.y;i<xy1.y;i+=3){
	for(int j=xy.x;j<xy1.x;j+=3){
	   if(aa[i*WIDTH+j]>0){
		if(zz[i*WIDTH+j]>0){
		if(zz[i*WIDTH+j]<BACK){
		    sum_z+=zz[i*WIDTH+j];
		    sum_y+=yy[i*WIDTH+j];
		    sum_x+=xx[i*WIDTH+j];
		    num++;
		    }
		}
	    }
	}
    }
    if(num!=0) {
	ave_x=sum_x/num;
	ave_y=sum_y/num;
	ave_z=sum_z/num;
    }
   	else      {
	ave_x=0.0;
	ave_y=0.0;
	ave_z=0.0;
	}
	person_x=(double)ave_x;
	person_y=(double)ave_y;
	person_z=(double)ave_z;
}

void VisionInput(IplImage* image,IplImage *image2,double *dist){
    frame=image;
    object=image2;
    target2=image2;
    distant=dist;

}


void Vision3DInput(double *x,double *y,double *z,int *a){
    xx_v=x;
    yy_v=y;
    zz_v=z;
    aa_v=a;
}


void VisionOutput(double &x,double &y,double &z){
    x=person_vision_x;
    y=person_vision_y;
    z=person_vision_z;
}

void CalPanTilt(double target_x,double target_y,double &pan,double &tilt){
    double target_thita=0;
    double thita=0;
    double target_r=0;
   
    target_r = sqrt(target_x*target_x+target_y*target_y);
    if(target_r!=0){
	if(target_y>=0){
	    thita=acos(target_x/target_r);
	    thita=thita*180.0/PI;
	}
	else if(target_y<0){
	    thita=acos(target_x/target_r);
	    thita=360.0-thita*180.0/PI;
	}
    
	if(target_thita>=90.0)    target_thita=thita-90.0;
	else if(target_thita<90.0)  target_thita=thita-90.0;
	if(target_thita>180.0) target_thita=target_thita-360.0;
    }

    pan=target_thita*PI/180.0;
    tilt=0;
}


void VisionLoop(){
  key = cvWaitKey(10);
  //static int count=0;
  static int count=1;
  key=key&0xff;
  
  
  if( key ==10 ){
    mouse_flg=0;
    cvShowImage("ColorImage",frame);
    cvWaitKey(-1);
    mouse_flg=1;
    if(temp)		{
      initHist(HShistgram);
      initGau(Gaussian);
      
      makeHist(temp,HShistgram,hstable);
      NoiseFilter(HShistgram);
      MedianFilter(HShistgram);
      NNClustering(HShistgram,&clust,30);
      getGaussian(&clust,HShistgram,Gaussian);
      inputClusterData(hsv_ori,&clust);
      inputHShist(Gaussian,HSGaussian,plot_count);
      
      OutputHsv(HShistgram,hsv);
      OutputGau(Gaussian,gau);
      
      //cvShowImage("hshist_ori",hsv_ori);
      //cvShowImage("hshist_ori2",hsv);
      //cvShowImage("Gaussian",gau);
      count++;
      
    }
  }
  
  
  if(count!=0){
    ColorExtract2(target,object,HShistgram,hstable);
    RectDetec(HShistgram,hstable,object,&proxmax,&proymax,&xy,&xy1);
    
    if(xy1.x-xy.x>40 && xy1.y-xy.y>50 &&xy1.x-xy.x<300 && xy1.y-xy.y<240&& proxmax>50 && proymax>30){
      person_position_x=(xy1.x+xy.x)/2;
      person_position_y=(xy1.y+xy.y)/2;
      
      vision_area_x_up=xy.x;
      vision_area_y_up=xy.y;
      vision_area_x_down=xy1.x;
      vision_area_y_down=xy1.y;
      
      upext=cvCreateImage(cvSize(xy1.x-xy.x,xy1.y-xy.y),8,3); 
      
      Crop(object,upext,xy,xy1);
      makeHist(upext,ExtHist,hstable);
      upHist(HShistgram,ExtHist,HSGaussian,plot_count);
      //OutputHsv(ExtHist,hsv_ori);
      //ExtHistInit(ExtHist);
      NoiseFilter(ExtHist);
      MedianFilter(ExtHist);
	OutputExt(ExtHist,hsv_ori3);
	ExtHistInit(ExtHist);
	//cvShowImage("hshist_ori3",hsv_ori3);
	
	cvReleaseImage(&upext);
	
	PositionCal(xx_v,yy_v,zz_v,aa_v,xy,xy1,person_vision_x,person_vision_y,person_vision_z,BACK);
	
	OutputHsv(HShistgram,hsv);
	
    }
    
    else{
      person_vision_x=0;
      person_vision_y=0;
      person_vision_z=0;
      
      vision_area_x_up=0;
      vision_area_y_up=0;
      vision_area_x_down=0;
      vision_area_y_down=0;
      
    }
  }
  
  cvRectangle(frame,xy,xy1,CV_RGB(0,255,0),2,8,0);
  if(person_vision_z!=0){
    sprintf(distanceTxt,"%.2f",person_vision_z);
    cvPutText(frame,distanceTxt,cvPoint(0,20),&font,CV_RGB(255,0,0));
  }
  
  cvShowImage("ColorImage",frame);
  //cvShowImage("target",target);
  //cvShowImage("target2",target2);
  //cvShowImage("disp",disp);
  //cvShowImage("hshist",hsv);
  //cvShowImage("hshist_ori",hsv_ori);
  
}


void VisionInit(string c_space,double back_length){
    BACK=back_length;
    cvInitFont(&font,CV_FONT_HERSHEY_DUPLEX,0.8f,0.8f,0.0,1,5);

    for(int i=0;i<WIDTH*HEIGHT;i++){
        target2->imageData[i*3+2]=0;
        target2->imageData[i*3+1]=0;
        target2->imageData[i*3]=0;
}
    xy.x=0,xy.y=0,xy1.x=0,xy1.y=0;
    
        //cvNamedWindow("hshist",CV_WINDOW_AUTOSIZE);
       //cvNamedWindow("hshist_ori",CV_WINDOW_AUTOSIZE);
   //    cvNamedWindow("hshist_ori2",CV_WINDOW_AUTOSIZE);
        //cvNamedWindow("Gaussian",CV_WINDOW_AUTOSIZE);
    //cvNamedWindow("target",CV_WINDOW_AUTOSIZE);
    //cvNamedWindow("target2",CV_WINDOW_AUTOSIZE);
    cvNamedWindow("temp",CV_WINDOW_AUTOSIZE);
    cvNamedWindow("ColorImage",CV_WINDOW_AUTOSIZE);
    //cvNamedWindow("disp",CV_WINDOW_AUTOSIZE);
    //cvNamedWindow("hshist_ori3",CV_WINDOW_AUTOSIZE);

    cvSetMouseCallback("ColorImage",OnMouse);
    ColorSpaceLoad(hstable,c_space);
    //修正箇所
      temp=cvCreateImage(cvSize(36,52),8,3);//width,heightは4の倍数
      temp= cvLoadImage("temp_demo.png");
      if(temp)		{
	    initHist(HShistgram);
	    initGau(Gaussian);

	    makeHist(temp,HShistgram,hstable);
	    NoiseFilter(HShistgram);
	    MedianFilter(HShistgram);
	    NNClustering(HShistgram,&clust,30);
	    getGaussian(&clust,HShistgram,Gaussian);
	    inputClusterData(hsv_ori,&clust);
	    inputHShist(Gaussian,HSGaussian,plot_count);

	    OutputHsv(HShistgram,hsv);
	    OutputGau(Gaussian,gau);

            //cvShowImage("temp",temp);
	    //cvShowImage("hshist_ori",hsv_ori);
	    //cvShowImage("hshist_ori2",hsv);
	    //cvShowImage("Gaussian",gau);
            
	}
      //  ここまで		    
    fprintf(stderr,"\n");
    fprintf(stderr,"Vision Control Command\n");
    fprintf(stderr,"   ENTER -- STOP\n");
    fprintf(stderr,"    ESC  -- EXIT\n");
    fprintf(stderr,"\n");

}    

void VisionEnd(){



    cvDestroyWindow("ColorImage");
  //  cvDestroyWindow("disp");
 //   cvDestroyWindow("hshist");
//cvDestroyWindow("hshist_ori");
//  cvDestroyWindow("hshist_ori2");
  //cvDestroyWindow("Gaussian");
  //cvDestroyWindow("target");
    cvDestroyWindow("target2");
  cvDestroyWindow("temp");
	
cvWaitKey(10);
cvWaitKey(10);

}


void OnMouse(int event, int x, int y, int flags, void *param){
    extern IplImage* frame;
    extern IplImage* temp;
    extern bool mouse_flg;

    static IplImage* rect=cvCreateImage(cvSize(WIDTH,HEIGHT),8,3);
    static int number=1;//修正箇所
    //static int number;
    static int mouse_move;
    static CvPoint pt_lu,pt_rd; 

    cvCopy(frame,rect,0);
    if( !frame ) return;
    if(mouse_flg==1) return;

    if( event == CV_EVENT_LBUTTONDOWN ){
	pt_lu = cvPoint(x,y);
	mouse_move=1;
    }
    if( event == CV_EVENT_MOUSEMOVE && mouse_move==1)
	cvRectangle( rect, pt_lu,cvPoint(x,y),CV_RGB(255,0,0),2,8,0);

    if( event == CV_EVENT_LBUTTONUP ){
	pt_rd = cvPoint(x,y);
	if((abs(pt_rd.x-pt_lu.x)<20)||(abs(pt_rd.y-pt_lu.y)<20)) {
	    mouse_move=0;
	    return;
	}
	if((pt_rd.x<pt_lu.x)||(pt_rd.y<pt_lu.y)) {
	    mouse_move=0;
	    return;
	}

	if((pt_rd.x-pt_lu.x)%4!=0)  pt_rd.x=pt_rd.x-(pt_rd.x-pt_lu.x)%4;
	if((pt_rd.y-pt_lu.y)%4!=0)  pt_rd.y=pt_rd.y-(pt_rd.y-pt_lu.y)%4;
	if(number==0){
	    temp=cvCreateImage(cvSize((pt_rd.x-pt_lu.x),(pt_rd.y-pt_lu.y)),8,3);
	}
	if(number==1){
	    cvReleaseImage(&temp);
	    cvReleaseImage(&temp);
	    temp=cvCreateImage(cvSize((pt_rd.x-pt_lu.x),(pt_rd.y-pt_lu.y)),8,3);
	}

	cvDestroyWindow("temp");
	cvNamedWindow("temp",CV_WINDOW_AUTOSIZE);
	Crop(frame,temp,pt_lu,pt_rd);
	cvShowImage("temp",temp);
	cvSaveImage("temp.png",temp);
	cvWaitKey(10);
	mouse_flg=1;
	number=1;
	mouse_move=0;
    }
    cvShowImage("ColorImage",rect);
}



void PanTiltControl(double panin,double tiltin,double &panout,double &tiltout){
    double pan,tilt;
    if((person_vision_x!=0)&&(person_vision_z!=0)&&(person_vision_z>=0))
  	{
	    CalPanTilt(-person_vision_x,person_vision_z,pan,tilt);
	    panout = panin+pan;
	}
    else{
	panout = panin;
    }
	

}

void HShistOut(IplImage* Updatehsv){
    memcpy((void *)&(Updatehsv->imageData),hsv->imageData,hsv->imageSize);

}



