#!/bin/sh

rtc-template -bcxx \
    --module-name=HumanDetection_Camera --module-type='DataFlowComponent' \
    --module-desc='HumanDetection_Camera component' \
    --module-version=1.0 --module-vendor='Nemoto,Mizoguchi Lab,Tokyo University of Science' \
    --module-category=RobotModule \
    --module-comp-type=DataFlowComponent --module-act-type=SPORADIC \
    --module-max-inst=10      \
    --inport=Color:TimedOctetSeq     \
    --inport=Disparity:TimedOctetSeq     \
    --inport=XYZData:TimedXYZLongSeq     \
    --inport=HeadAngle:TimedPanTilt     \
    --outport=PosOnImg:TimedDoubleSeq     \
    --outport=AreaOnImg:TimedDoubleSeq     \
    --outport=TargetPos:TimedOdometry     \
    --outport=Target3DPos:TimedXYZDouble     \
    --outport=TargetAngle:TimedPanTilt     \
    --outport=UpdateHSHist:TimedOctetSeq     \
    --config="ColorSpace:std::string:HSV"  \
    --config="BackGround_Disp:int:200"  \
    --config="BackGround_XYZ:double:3.000"  \
    --config="Tilt_Rotation:bool:false"  \
	--consumer=CapPORT:CameraInfo:CameraInfo \
    --consumer-idl=MyDataType.idl \

